import time
import sys

k_states = 3
x1 = 0
x2 = 0
data_input = [1,2,0,1,1,1,2,0,1,2,1,2,0,1,2,1,0,0,0,1,2,1,2,1,0,2,0,2,1,2,1,2,1,1,1,0,1,0,1,0,1,0]
numb_inputs = len(data_input)-1
row = [0, 0, 0]

#create the transisiton matrix
turn_out_matrix = [[0 for x in range(k_states)] for x in range(k_states)]
prob_matrix = [[0 for x in range(k_states)] for x in range(k_states)]

def MarkovChain(s):

    #count the number of times each state has a transition to the next state
    t=0
    while t<numb_inputs:
        turn_out_matrix[data_input[t]][data_input[t+1]]+=1
        t+=1

    #calculate the total of each row transistions
    for i in range(0, 3):
        for j in range(0, 3):
            row[i]+=turn_out_matrix[i][j]

    #calculate the probability of every transistion         
    for i in range(0, 3):
        for j in range(0, 3):
            prob_matrix[i][j] = turn_out_matrix[i][j]/float(row[i])

    return prob_matrix[s].index(max(prob_matrix[s]))


print MarkovChain(2)
print turn_out_matrix
#print row
print prob_matrix
